class Public::AcquiredMediaReleasesController < Public::BaseController
  include CreateReleasableJobs
  before_action :set_account, :set_project, :set_contract_template

  def new
    @acquired_media_release = build_acquired_media_release
  end

  def create
    @acquired_media_release = build_acquired_media_release(acquired_media_release_params_with_locale_and_contract_template)

    if @acquired_media_release.save(context: :native)
      log_create_analytics
      after_create(@acquired_media_release)
    else
      render :new
    end
  end

  private

  def set_project
    @project = @account.projects.find(params[:project_id])
  end

  def set_account
    @account = Account.find_by(slug: params[:account_id])
  end

  def set_contract_template
    @contract_template = @project.contract_templates.find(params[:contract_template_id])
  end

  def acquired_media_releases
    policy_scope(@project.acquired_media_releases)
  end

  def build_acquired_media_release(params = {})
    acquired_media_releases.build(params).tap do |acquired_media_release|
      authorize(acquired_media_release)
    end
  end

  def acquired_media_release_params
    params.require(:acquired_media_release).permit(
      :name, 
      :description,
      :person_first_name,
      :person_last_name,
      :person_email,
      :person_title,
      :person_phone,
      :person_fax,
      :person_address_street1, 
      :person_address_street2, 
      :person_address_city, 
      :person_address_state, 
      :person_address_zip, 
      :person_address_country,
      :signature_base64,
      :locale, :contract_template,
      categories: [],
      file_infos_attributes: [
        :filename,
        :content_type,
        :byte_size
      ]
    )
  end

  def acquired_media_release_params_with_locale
    acquired_media_release_params.merge(locale: I18n.locale)
  end

  def acquired_media_release_params_with_locale_and_contract_template
    acquired_media_release_params_with_locale.merge(contract_template: @contract_template)
  end

  def log_create_analytics
    TrackAnalyticsJob.perform_later(nil, nil, :track_create_native_release, release_type: AcquiredMediaRelease.to_s, account: @account, user_agent: request.user_agent, user_ip: request.remote_ip)
  end
end
